#ifndef HARK_SUPPORT_H
#define HARK_SUPPORT_H

// for Julius_MFT mfcnet (feature) input support
#ifdef _MSC_VER
#define ATTRIBUTE_PACKED
#pragma pack(push,1)
#else
#define ATTRIBUTE_PACKED __attribute__ ((packed))
#endif
struct SourceInfo {
  int32_t source_id;
  float azimuth;
  float elevation;
  int64_t tv_sec;
  int64_t tv_usec;
} ATTRIBUTE_PACKED;
#ifdef _MSC_VER
#pragma pack(pop)
#undef ATTRIBUTE_PACKED
#else
#undef ATTRIBUTE_PACKED
#endif

// for HARK HarkDataStreamSender (Separated acoustic PCM data and etc...) input support (yet)
#ifdef _MSC_VER
#define ATTRIBUTE_PACKED
#pragma pack(push,1)
#else
#define ATTRIBUTE_PACKED __attribute__ ((packed))
#endif
struct HD_Header {
  int32_t type;
  int32_t advance;
  int32_t count;
  int64_t tv_sec;
  int64_t tv_usec;
} ATTRIBUTE_PACKED;
#ifdef _MSC_VER
#pragma pack(pop)
#undef ATTRIBUTE_PACKED
#else
#undef ATTRIBUTE_PACKED
#endif

#ifdef _MSC_VER
#define ATTRIBUTE_PACKED
#pragma pack(push,1)
#else
#define ATTRIBUTE_PACKED __attribute__ ((packed))
#endif
struct HD_Header_V1old {
  int32_t type;
  int32_t advance;
  int32_t count;
} ATTRIBUTE_PACKED;
#ifdef _MSC_VER
#pragma pack(pop)
#undef ATTRIBUTE_PACKED
#else
#undef ATTRIBUTE_PACKED
#endif

#ifdef _MSC_VER
#define ATTRIBUTE_PACKED
#pragma pack(push,1)
#else
#define ATTRIBUTE_PACKED __attribute__ ((packed))
#endif
struct HDH_MicData {
  int32_t nch;
  int32_t length;
  int32_t data_bytes;
} ATTRIBUTE_PACKED;
#ifdef _MSC_VER
#pragma pack(pop)
#undef ATTRIBUTE_PACKED
#else
#undef ATTRIBUTE_PACKED
#endif

#ifdef _MSC_VER
#define ATTRIBUTE_PACKED
#pragma pack(push,1)
#else
#define ATTRIBUTE_PACKED __attribute__ ((packed))
#endif
struct HDH_SrcInfo {
  int32_t src_id;
  float x[3];
  float power;
} ATTRIBUTE_PACKED;
#ifdef _MSC_VER
#pragma pack(pop)
#undef ATTRIBUTE_PACKED
#else
#undef ATTRIBUTE_PACKED
#endif

#ifdef _MSC_VER
#define ATTRIBUTE_PACKED
#pragma pack(push,1)
#else
#define ATTRIBUTE_PACKED __attribute__ ((packed))
#endif
struct HDH_SrcData {
  int32_t length;
  int32_t data_bytes;
} ATTRIBUTE_PACKED;
#ifdef _MSC_VER
#pragma pack(pop)
#undef ATTRIBUTE_PACKED
#else
#undef ATTRIBUTE_PACKED
#endif

#endif // HARK_SUPPORT_H
