// online-mfcnet.h
// If you want to put this file under the directory, it file is placed in under the "feat" directory.
// Implements like "feat/online-feature.h".

#ifndef ONLINE_FEATURE_MFCNET_H
#define ONLINE_FEATURE_MFCNET_H

#include "itf/online-feature-itf.h"
#include <Poco/Net/StreamSocket.h>
#include "hark-support.h"

namespace kaldi {

class OnlineFeatureMfcnet : public OnlineFeatureInterface {
 public:
  OnlineFeatureMfcnet(const Poco::Net::StreamSocket& socket);

  virtual ~OnlineFeatureMfcnet();

  virtual kaldi::int32 Dim() const;

  virtual kaldi::int32 NumFramesReady() const;

  virtual bool IsLastFrame(kaldi::int32 frame) const;

  virtual BaseFloat FrameShiftInSeconds() const;

  virtual void GetFrame(kaldi::int32 frame, kaldi::VectorBase<kaldi::BaseFloat> *feat);

  void Receive();

  const SourceInfo& GetSourceInfo() { return source_info_; }

 private:
  Poco::Net::StreamSocket socket_;
  kaldi::int32 feat_dim_;
  kaldi::int32 begin_frame_;
  kaldi::int32 num_frames_;
  bool input_finished_;
  kaldi::Matrix<kaldi::BaseFloat> features_;
  SourceInfo source_info_;
  int frame_size_;
};

}

#endif // ONLINE_FEATURE_MFCNET_H
